%define	lib_major 1
%define	lib_name %mklibname %{name}%{lib_major}
%define	devel_name %mklibname %{name} -d
# for uClibc-zlib
%define	uClib_name %mklibname uClibc-%{name}%{lib_major}
%define	uClib_devel_name %mklibname uClibc-%{name} -d
%define libminizip %mklibname minizip %{lib_major}
%define minizip_devel %mklibname minizip -d

%define build_biarch 0
# Enable bi-arch build on ppc64, sparc64 and x86-64
%ifarch sparcv9 sparc64 x86_64 ppc64
%define build_biarch 1
%endif
%ifarch sparcv9
%define	_lib	lib64
%endif
%define build_minizip 1

%bcond_without uclibc
%bcond_without dietlibc

Summary:	The zlib compression and decompression library
Name:		zlib
Version:	1.2.7
Release:	%mkrel 7
Group:		System/Libraries
License:	BSD
URL:		http://www.gzip.org/zlib/
Source0:	http://prdownloads.sourceforge.net/libpng/%{name}-%{version}.tar.gz
Patch1:		zlib-1.2.6-multibuild.patch
Patch2:		zlib-1.2.5-lfs-decls.patch
BuildRequires:	util-linux
%if %{with uclibc}
BuildRequires:	uClibc-devel >= 0.9.30.3-2
%endif
%if %{with dietlibc}
BuildRequires:	dietlibc-devel
%endif
%if %build_minizip
BuildRequires: zlib-devel
%endif

%description
The zlib compression library provides in-memory compression and
decompression functions, including integrity checks of the uncompressed
data.  This version of the library supports only one compression method
(deflation), but other algorithms may be added later, which will have
the same stream interface.  The zlib library is used by many different
system programs.

%package -n	%{lib_name}
Summary:	The zlib compression and decompression library
Group:		System/Libraries
Requires(pre):	filesystem >= 2.1.9-18
Obsoletes:	libz, libz1, %{name}
Obsoletes:	%{name}%{lib_major} < 1.2.5
Provides:	libz = %{version}-%{release} libz1 = %{version}-%{release} %{name} = %{version}-%{release}

%description -n	%{lib_name}
The zlib compression library provides in-memory compression and
decompression functions, including integrity checks of the uncompressed
data.  This version of the library supports only one compression method
(deflation), but other algorithms may be added later, which will have
the same stream interface.  The zlib library is used by many different
system programs.

%package -n	%{devel_name}
Summary:	Header files and libraries for developing apps which will use zlib
Group:		Development/C
Requires:	%{lib_name} = %{version}-%{release}
Obsoletes:	libz1-devel libz-devel zlib-devel zlib1-devel
Obsoletes:	%{name}%{lib_major}-devel < 1.2.5
Provides:	libz-devel = %{version}-%{release} lib%{name}-devel = %{version}-%{release} %{name}-devel = %{version}-%{release}

%description -n	%{devel_name}
The zlib-devel package contains the header files and libraries needed
to develop programs that use the zlib compression and decompression
library.

Install the zlib-devel package if you want to develop applications that
will use the zlib library.

%if %build_minizip
%package -n     %{libminizip}
Summary:        Minizip manipulates files from a .zip archive
Group:          System/Libraries

%description -n %{libminizip}
Minizip manipulates files from a .zip archive.

%package -n     %{minizip_devel}
Summary:        Development files for the minizip library
Group:          Development/C
Requires:       %{libminizip} = %{version}-%{release}
Requires:       zlib-devel = %{version}-%{release}
Provides:       libminizip-devel = %{version}-%{release}
Provides:       minizip-devel = %{version}-%{release}

%description -n %{minizip_devel}
This package contains the libraries and header files needed for
developing applications which use minizip.
%endif

%if %{with uclibc}
%package -n	%{uClib_name}
Summary:	The uClibc-zlib compression and decompression library
Group:		System/Libraries
Conflicts:	%{lib_name} < 1.2.5-4
Requires:	%{lib_name} = %{version}-%{release}
Provides:	uClibc-zlib = %{version}-%{release} uClibc-zlib1 = %{version}-%{release}
Obsoletes:	uClibc-zlib <= %{version}-%{release} uClibc-zlib1 <= %{version}-%{release}

%description -n	%{uClib_name}
The uClibc-zlib compression library provides in-memory compression and
decompression functions, including integrity checks of the uncompressed
data.  This version of the library supports only one compression method
(deflation), but other algorithms may be added later, which will have
the same stream interface.  The zlib library is used by many different
system programs.

%package -n	%{uClib_devel_name}
Summary:	Header files and libraries for developing apps which will use uClibc-zlib
Group:		Development/C
Conflicts:	%{devel_name} < 1.2.5-4
Requires:	%{devel_name} = %{version}-%{release}
Requires:	%{uClib_name} = %{version}-%{release}
Provides:	uClibc-zlib-devel = %{version}-%{release} uClibc-zlib1-devel = %{version}-%{release}
Obsoletes:	uClibc-zlib-devel <= %{version}-%{release} uClibc-zlib1-devel <= %{version}-%{release}

%description -n	%{uClib_devel_name}
The uClibc-zlib-devel package contains the header files and libraries
needed to develop programs that use the zlib compression and decompression
library.

Install the uClibc-zlib-devel package if you want to develop applications that
will use the uClibc-zlib library.
%endif # with uclibc

%prep
%setup -q
#patch1 -p1 -b .multibuild

%build
#(peroyvind): be sure to remove -m64/-m32 flags as they're not overridable
RPM_OPT_FLAGS="`echo $RPM_OPT_FLAGS| sed -e 's/-m.. //g'` -O3"
mkdir objs
cp -a $(ls | grep -v objs) objs/
pushd objs
  CFLAGS="$RPM_OPT_FLAGS" LDFLAGS="%{?ldflags}" \
%if %{build_biarch}
  CC="%{__cc} -m64" \
%endif
  ./configure --shared --prefix=%{_prefix} --libdir=%{_libdir}
  %make
  make test
popd

%if %build_minizip
pushd contrib/minizip
autoreconf --install
%configure --enable-static=no
%make
popd
%endif

%if %{build_biarch}
%ifarch %{sunsparc}
RPM_OPT_FLAGS_32="$RPM_OPT_FLAGS"
%else
RPM_OPT_FLAGS_32=`linux32 rpm --eval %%optflags`
%endif
mkdir objs32
cp -a $(ls | grep -v objs) objs32/
pushd objs32
  CFLAGS="$RPM_OPT_FLAGS_32" LDFLAGS="%{?ldflags}" CC="%{__cc} -m32" \
  ./configure --shared --prefix=%{_prefix}
  %make
  make test
popd
%endif

%if %{with dietlibc}
mkdir objsdietlibc
cp -a $(ls | grep -v objs) objsdietlibc/
pushd objsdietlibc
  CFLAGS="-Os" CC="diet gcc" \
  ./configure --prefix=%{_prefix}
  %make libz.a
popd
%endif

%if %{with uclibc}
mkdir objsuclibc
cp -a $(ls | grep -v objs) objsuclibc/
pushd objsuclibc
  CFLAGS="%{uclibc_cflags}" LDFLAGS="%{?ldflags}" CC="%{uclibc_cc}" \
  ./configure --shared --prefix=%{_prefix}
  %make
popd
%endif

%install
rm -rf %{buildroot}

install -d %{buildroot}/%{_prefix}
install -d %{buildroot}/%{_libdir}

make install -C objs prefix=%{buildroot}%{_prefix} libdir=%{buildroot}%{_libdir}
%if %{build_biarch}
make install-libs -C objs32 prefix=%{buildroot}%{_prefix}
%endif

%if %build_minizip
pushd contrib/minizip
%makeinstall_std
popd
%endif

%if %{with dietlibc}
install -m644 objsdietlibc/libz.a -D %{buildroot}%{_prefix}/lib/dietlibc/lib-%{_arch}/libz.a
%endif

%if %{with uclibc}
#install -m644 objsuclibc/libz.a -D %{buildroot}%{uclibc_root}%{_libdir}/libz.a
make install-libs -C objsuclibc prefix=%{buildroot}%{uclibc_root} libdir=%{buildroot}%{uclibc_root}%{_libdir}
rm -fr %{buildroot}%{uclibc_root}/share/man %{buildroot}%{uclibc_root}/usr/lib*/pkgconfig
%endif

%if %build_minizip
rm -fr %{buildroot}%_libdir/libminizip.la
%endif

%clean
rm -fr %{buildroot}

%files -n %{lib_name}
%doc README
%{_libdir}/libz.so.%{lib_major}*
%if %{build_biarch}
%{_prefix}/lib/libz.so.%{lib_major}*
%endif

%files -n %{devel_name}
%doc README ChangeLog doc/algorithm.txt
%{_mandir}/man3/zlib.3*
%{_libdir}/*.a
%{_libdir}/*.so
%if %build_minizip
%exclude %{_libdir}/libminizip.so
%endif
%{_libdir}/pkgconfig/zlib.pc
%if %{build_biarch}
%{_prefix}/lib/*.a
%{_prefix}/lib/*.so
%{_prefix}/lib/pkgconfig/zlib.pc
%endif
%{_includedir}/zconf.h
%{_includedir}/zlib.h
%if %{with dietlibc}
%{_prefix}/lib/dietlibc/lib-%{_arch}/libz.a
%endif

%if %build_minizip
%files -n %{libminizip}
%{_libdir}/libminizip.so.%{lib_major}*

%files -n %{minizip_devel}
%{_libdir}/pkgconfig/minizip.pc
%{_libdir}/libminizip.so
%{_includedir}/minizip
%endif

%if %{with uclibc}
%files -n %{uClib_name}
%{uclibc_root}%{_libdir}/libz.so.%{lib_major}*

%files -n %{uClib_devel_name}
%{uclibc_root}%{_libdir}/libz.so
%{uclibc_root}%{_libdir}/libz.a
%endif # with uclibc


%changelog

* Mon Jan 14 2013 umeabot <umeabot> 1.2.7-7.mga3
+ Revision: 387754
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Mon Sep 17 2012 fwang <fwang> 1.2.7-6.mga3
+ Revision: 294833
- bump rel

* Mon Sep 17 2012 fwang <fwang> 1.2.7-5.mga3
+ Revision: 294829
- setarch merged into util-linux

* Sat Jul 21 2012 colin <colin> 1.2.7-4.mga3
+ Revision: 273158
- Update for usrmove

* Sat Jul 07 2012 dmorgan <dmorgan> 1.2.7-3.mga3
+ Revision: 268555
- Build minizip

* Tue May 29 2012 shlomif <shlomif> 1.2.7-1.mga3
+ Revision: 248898
- New version: 1.2.7

* Mon Jan 30 2012 fwang <fwang> 1.2.6-1.mga2
+ Revision: 203353
- new version 1.2.6

* Fri Oct 28 2011 tmb <tmb> 1.2.5-5.mga2
+ Revision: 159068
- split out uClibc-zlib(-devel) in separate rpms so basesystem-minimal
  does not require uClibc anymore.
- drop buildroot and defattr

* Sat Jan 08 2011 blino <blino> 1.2.5-3.mga1
+ Revision: 448
- imported package zlib

